using NUnit.Framework;
using System;
using EdabitDesafioTeam11;
using System.Collections.Generic;
using System.Linq;

namespace TestsDesafio
{
    public class Tests
    {
        EdabitChallenges edabitChallenges;

        [SetUp]
        public void Setup()
        {
            edabitChallenges = new EdabitChallenges();
        }

        #region VeryEasy
        [TestCase(3, 2, ExpectedResult = 5)]
        [TestCase(-3, -6, ExpectedResult = -9)]
        [TestCase(7, 3, ExpectedResult = 10)]
        public int GiveTwoNumbers_Sum(int num1, int num2)
        {
            return edabitChallenges.Sum(num1, num2);
        }

        [TestCase(5, ExpectedResult = 300)]
        [TestCase(3, ExpectedResult = 180)]
        [TestCase(2, ExpectedResult = 120)]
        public int GivenInt_Convert_ToSeconds(int minutes)
        {
            return edabitChallenges.MinutesToSecond(minutes);
        }

        [TestCase(0, ExpectedResult = 1)]
        [TestCase(9, ExpectedResult = 10)]
        [TestCase(-3, ExpectedResult = -2)]
        public int Get_Next_Number_Of_Integer(int num)
        {
            return edabitChallenges.Addition(num);
        }

        [TestCase(3, ExpectedResult = 180)]
        [TestCase(4, ExpectedResult = 360)]
        [TestCase(6, ExpectedResult = 720)]
        public int GetSum_Of_Polygon_Angles(int num)
        {
            return edabitChallenges.SumPolygon(num);
        }

        [TestCase(0)]
        public void GetError_OfPolygonAnglesSum_WhenNumberIsLessEqualThanTwo(int num)
        {
            Assert.That(() => edabitChallenges.SumPolygon(num), Throws.TypeOf<ArgumentException>());
        }

        [TestCase("is better than nothing", ExpectedResult = "something is better than nothing")]
        [TestCase("Bob Jane", ExpectedResult = "something Bob Jane")]
        [TestCase("something", ExpectedResult = "something something")]
        public string GivenAnInput_ReturnAString_WithPrefixSomething(string a)
        {
            return edabitChallenges.GiveMeSomething(a);
        }

        #endregion VeryEasy

        #region Easy
        [TestCase(3, ExpectedResult = "March")]
        [TestCase(12, ExpectedResult = "December")]
        [TestCase(6, ExpectedResult = "June")]
        public string GivenANumber_ReturnAMonth(int num)
        {
            return edabitChallenges.MonthName(num);
        }

        [TestCase(-3)]
        [TestCase(13)]
        public void GivenAnInvalidMonthNumber_ReturnAnException(int num)
        {
            Assert.That(() => edabitChallenges.MonthName(num), Throws.TypeOf<ArgumentException>());
        }

        [TestCase("aaaaaa", ExpectedResult = true)]
        [TestCase("aabaaa", ExpectedResult = false)]
        [TestCase("ccccca", ExpectedResult = false)]
        [TestCase("kk", ExpectedResult = true)]
        [TestCase("abc", ExpectedResult = false)]
        public bool GivenAnInput_CheckIfAllCharacters_AreIdentical(string str)
        {
            return edabitChallenges.IsIdentical(str);
        }


        [TestCase("ClaClaClaClap!", ExpectedResult = 4)]
        [TestCase("ClClClaClaClaClap!", ExpectedResult = 6)]
        [TestCase("CCClaClClap!Clap!ClClClap!", ExpectedResult = 9)]
        public int GivenAString_CountsClaps_ReturnAmount(string txt)
        {
            return edabitChallenges.CountClaps(txt);
        }

        [Test]
        public void GivenAnArrayOfArrays_ReturnArrayWithLargestNumberOfEachArray()
        {
            double[][] testCase1 = new double[][]
            {
                new double[] {4, 2, 7, 1},
                new double[] {20, 70, 40, 90},
                new double[] {1, 2, 0},
            };

            double[][] testCase2 = new double[][]
           {
                new double[] {-34, -54, -74},
                new double[] {-32, -2, -65},
                new double[] {-54, 7, -43},
           };

            double[][] testCase3 = new double[][]
            {
                new double[] {0.421, 0.7634, 0.652},
                new double[] {1.324, 9.32, 2.5423, 6.4314},
                new double[] {9, 3, 6, 3},
            };

            var resultado1 = edabitChallenges.FindLargest(testCase1);
            var resultado2 = edabitChallenges.FindLargest(testCase2);
            var resultado3 = edabitChallenges.FindLargest(testCase3);

            Assert.AreEqual(new double[] { 7, 90, 2 }, resultado1);
            Assert.AreEqual(new double[] { -34, -2, 7 }, resultado2);
            Assert.AreEqual(new double[] { 0.7634, 9.32, 9 }, resultado3);
        }

        [TestCase(new int[] { 1, 2, 3, 4, 5, 6, 7 }, ExpectedResult = "Boom!")]
        [TestCase(new int[] { 8, 6, 33, 100 }, ExpectedResult = "there is no 7 in the array")]
        [TestCase(new int[] { 2, 55, 60, 97, 86 }, ExpectedResult = "Boom!")]
        [TestCase(new int[] { }, ExpectedResult = "there is no 7 in the array")]
        public string GivenAnArray_CheckIfContains7_ReturnsBoom(int[] arr)
        {
            return edabitChallenges.SevenBoom(arr);
        }

        #endregion Easy

        #region Medium

        [TestCase("Happy Birthday", ExpectedResult = "hAPPY bIRTHDAY")]
        [TestCase("MANY THANKS", ExpectedResult = "many thanks")]
        [TestCase("sPoNtAnEoUs", ExpectedResult = "SpOnTaNeOuS")]
        public string GivenAnString_ReturnReverseCase(string str)
        {
            return edabitChallenges.ReverseCase(str);
        }

        [TestCase("4556364607935616", ExpectedResult = "############5616")]
        [TestCase("64607935616", ExpectedResult = "#######5616")]
        [TestCase("1", ExpectedResult = "1")]
        [TestCase("", ExpectedResult = "")]
        public string GivenAnString_ReturnMaskString(string str)
        {
            return edabitChallenges.Maskify(str);
        }

        [TestCase(1, true, ExpectedResult = false)]
        [TestCase(0, "0", ExpectedResult = false)]
        [TestCase(1, 1, ExpectedResult = true)]
        public bool GivenTwoValues_CheckIfBothAreEqualTypeAndValue_ReturnBool(object a, object b)
        {
            return edabitChallenges.CheckEquality(a, b);
        }

        [TestCase(2, 49, 65, ExpectedResult = 2)]
        [TestCase(3, 1, 27, ExpectedResult = 3)]
        [TestCase(10, 1, 5, ExpectedResult = 1)]
        [TestCase(5, 31, 33, ExpectedResult = 1)]
        [TestCase(4, 250, 1300, ExpectedResult = 3)]
        public int Given3Int_RaiseMinMax_ReturnCountRaisedNumberBetweenInterval(int power, int min, int max)
        {
            return edabitChallenges.PowerRanger(power, min, max);
        }

        [Test]
        public void ReturnUTF8Preamble()
        {
            Assert.AreEqual(new byte[] { 0xef, 0xbb, 0xbf }, edabitChallenges.GetUTF8BOM());
        }
        #endregion Medium

        #region Hard

        [Test]
        public void TestReverse()
        {
            Assert.AreEqual(new List<int> { 1, 2, 3 }, edabitChallenges.ReversedIntToList(321));
        }


        [TestCase(26, 39, ExpectedResult = 515)]
        [TestCase(122, 81, ExpectedResult = 1103)]
        [TestCase(1222, 30277, ExpectedResult = 31499)]
        public int GivenTwoInteger_ReturnMemeSum(int a, int b)
        {
            return edabitChallenges.MemeSum(a, b);
        }

        [Test]
        public void GivenAnIntArray_ReturnRobotPosition()
        {
            Assert.AreEqual(new int[] { -10, 10 }, edabitChallenges.TrackRobot(new int[] { 20, 30, 10, 40 }));
            Assert.AreEqual(new int[] { 0, 0 }, edabitChallenges.TrackRobot(new int[] { }));
            Assert.AreEqual(new int[] { 20, -20 }, edabitChallenges.TrackRobot(new int[] { -10, 20, 10 }));
        }

        [Test]
        public void GivenAnString_ReturnAStringWrappedByANumber()
        {
            Assert.AreEqual("llo, World!He", edabitChallenges.WrapAround("Hello, World!", 2));
            Assert.AreEqual("eredFrom what I gath", edabitChallenges.WrapAround("From what I gathered", -4));
            Assert.AreEqual("elsiorExc", edabitChallenges.WrapAround("Excelsior", 30));
            Assert.AreEqual("cienceNons", edabitChallenges.WrapAround("Nonscience", -116));
        }

        [Test]
        public void GivenAnArrayOfString_Swap_returnResults()
        {
            Assert.AreEqual("C", edabitChallenges.CupSwapping(new string[] { "AB", "CA" }));
            Assert.AreEqual("B", edabitChallenges.CupSwapping(new string[] { "AC", "CA", "CA", "AC" }));
            Assert.AreEqual("A", edabitChallenges.CupSwapping(new string[] { "BA", "AC", "CA", "BC" }));
            Assert.That(() => edabitChallenges.CupSwapping(new string[] { "ba" }), Throws.TypeOf<ArgumentException>());
        }

        [Test]
        public void GivenAnString_ConvertToHexadecimal_ReturnAnArrayOfHex()
        {
            Assert.AreEqual("68 65 6c 6c 6f 20 77 6f 72 6c 64", edabitChallenges.ConvertToHex("hello world"));
            Assert.AreEqual("42 69 67 20 42 6f 69", edabitChallenges.ConvertToHex("Big Boi"));
            Assert.AreEqual("4d 61 72 74 79 20 50 6f 70 70 69 6e 73 6f 6e", edabitChallenges.ConvertToHex("Marty Poppinson"));
        }

        #endregion

        #region VeryHard
        [TestCase("Eric", 2, "Adam Caroline Rebecca Frank", ExpectedResult = 40)]
        [TestCase("Zebediah", 1, "Bob Jim Becky Pat", ExpectedResult = 100)]
        [TestCase("Aaron", 3, "Jane Max Olivia Sam", ExpectedResult = 20)]
        public int GivenMeAgentsAmmountOther_ReturnTimeWait(string me, int agents, string others)
        {
            return edabitChallenges.License(me, agents, others);
        }

        [TestCase(new int[] { 2, 7, 6, 9, 5, 1, 4, 3, 8 }, ExpectedResult = true)]
        [TestCase(new int[] { 2, 7, 600, 9, 5, 1, -94, 3, 8 }, ExpectedResult = false)]
        [TestCase(new int[] { 2, 7, 50, 9, 555, 1, -9, 3, 8 }, ExpectedResult = false)]
        [TestCase(new int[] { 16, 3, 2, 13, 5, 10, 11, 8, 9, 6, 7, 12, 4, 15, 14, 1 }, ExpectedResult = true)]
        [TestCase(new int[] { 7, 12, 1, 14, 2, 13, 8, 11, 16, 3, 10, 5, 9, 6, 15, 4 }, ExpectedResult = true)]
        [TestCase(new int[] { 7, 12, 1, 14, 2, 13, 8, 11, 16, 3, 10, 5, 9, 6, 16, 5 }, ExpectedResult = false)]
        [TestCase(new int[] { 1, 14, 14, 4, 11, 7, 6, 9, 8, 10, 10, 5, 13, 2, 3, 15 }, ExpectedResult = true)]
        [TestCase(new int[] { 1, 14, 14, 4, 11, 7, 6, 9, 8, 11, 10, 5, 13, 2, 3, 15 }, ExpectedResult = false)]
        [TestCase(new int[] { 1, 15, 4, 14, 10, 11, 5, 8, 7, 6, 12, 9, 16, 2, 13, 3 }, ExpectedResult = false)]
        [TestCase(new int[] { 16, 3, 2, 13, 5, 10, 11, 8, 9, 6, 7, 12, 4, 15, 14, 1 }, ExpectedResult = true)]

        public bool GivenAMatriz_CheckIfIsAMagicSquate(int[] arr)
        {
            var size = (int)Math.Sqrt(arr.Length);
            var matrix = Enumerable.Range(0, size).Select(r => Enumerable.Range(0, size).Select(c => arr[r * size + c]).ToArray()).ToArray();
            return edabitChallenges.IsMagicSquare(matrix);
        }


        [TestCase("..<.<.", ExpectedResult = new int[] { 1, 1 })]
        [TestCase("....................................................................................................", ExpectedResult = new int[] { 100, 0 })]
        [TestCase("<>>>><><<<><>>>><><<<><>>><>", ExpectedResult = new int[] { 0, 0 })]
        [TestCase(".<..<...<....<.....<......", ExpectedResult = new int[] { 3, 4 })]
        [TestCase(">>..", ExpectedResult = new int[] { -2, 0 })]
        [TestCase("..<<..>>..<<..>>..", ExpectedResult = new int[] { 2, 0 })]
        public int[] GivenInstructions_ReturnRobotPosition(string steps)
        {
            return edabitChallenges.TrackRobot2(steps);
        }

        [Test]
        public void GivenAString_ReturnAllPosiblePermutations()
        {
            Assert.AreEqual(edabitChallenges.Permutations("AB"), "AB BA");
            Assert.AreEqual(edabitChallenges.Permutations("CD"), "CD DC");
            Assert.AreEqual(edabitChallenges.Permutations("EF"), "EF FE");
            Assert.AreEqual(edabitChallenges.Permutations("NOT"), "NOT NTO ONT OTN TNO TON");
            Assert.AreEqual(edabitChallenges.Permutations("RAM"), "AMR ARM MAR MRA RAM RMA");
            Assert.AreEqual(edabitChallenges.Permutations("YAW"), "AWY AYW WAY WYA YAW YWA");
            Assert.AreEqual(edabitChallenges.Permutations("FELT"), "EFLT EFTL ELFT ELTF ETFL ETLF FELT FETL FLET FLTE FTEL FTLE LEFT LETF LFET LFTE LTEF LTFE TEFL TELF TFEL TFLE TLEF TLFE");
            Assert.AreEqual(edabitChallenges.Permutations("LURE"), "ELRU ELUR ERLU ERUL EULR EURL LERU LEUR LREU LRUE LUER LURE RELU REUL RLEU RLUE RUEL RULE UELR UERL ULER ULRE UREL URLE");
            Assert.AreEqual(edabitChallenges.Permutations("ROME"), "EMOR EMRO EOMR EORM ERMO EROM MEOR MERO MOER MORE MREO MROE OEMR OERM OMER OMRE OREM ORME REMO REOM RMEO RMOE ROEM ROME");
            Assert.AreEqual(edabitChallenges.Permutations("COAST"), "ACOST ACOTS ACSOT ACSTO ACTOS ACTSO AOCST AOCTS AOSCT AOSTC AOTCS AOTSC ASCOT ASCTO ASOCT ASOTC ASTCO ASTOC ATCOS ATCSO ATOCS ATOSC ATSCO ATSOC CAOST CAOTS CASOT CASTO CATOS CATSO COAST COATS COSAT COSTA COTAS COTSA CSAOT CSATO CSOAT CSOTA CSTAO CSTOA CTAOS CTASO CTOAS CTOSA CTSAO CTSOA OACST OACTS OASCT OASTC OATCS OATSC OCAST OCATS OCSAT OCSTA OCTAS OCTSA OSACT OSATC OSCAT OSCTA OSTAC OSTCA OTACS OTASC OTCAS OTCSA OTSAC OTSCA SACOT SACTO SAOCT SAOTC SATCO SATOC SCAOT SCATO SCOAT SCOTA SCTAO SCTOA SOACT SOATC SOCAT SOCTA SOTAC SOTCA STACO STAOC STCAO STCOA STOAC STOCA TACOS TACSO TAOCS TAOSC TASCO TASOC TCAOS TCASO TCOAS TCOSA TCSAO TCSOA TOACS TOASC TOCAS TOCSA TOSAC TOSCA TSACO TSAOC TSCAO TSCOA TSOAC TSOCA");
            Assert.AreEqual(edabitChallenges.Permutations("SKATE"), "AEKST AEKTS AESKT AESTK AETKS AETSK AKEST AKETS AKSET AKSTE AKTES AKTSE ASEKT ASETK ASKET ASKTE ASTEK ASTKE ATEKS ATESK ATKES ATKSE ATSEK ATSKE EAKST EAKTS EASKT EASTK EATKS EATSK EKAST EKATS EKSAT EKSTA EKTAS EKTSA ESAKT ESATK ESKAT ESKTA ESTAK ESTKA ETAKS ETASK ETKAS ETKSA ETSAK ETSKA KAEST KAETS KASET KASTE KATES KATSE KEAST KEATS KESAT KESTA KETAS KETSA KSAET KSATE KSEAT KSETA KSTAE KSTEA KTAES KTASE KTEAS KTESA KTSAE KTSEA SAEKT SAETK SAKET SAKTE SATEK SATKE SEAKT SEATK SEKAT SEKTA SETAK SETKA SKAET SKATE SKEAT SKETA SKTAE SKTEA STAEK STAKE STEAK STEKA STKAE STKEA TAEKS TAESK TAKES TAKSE TASEK TASKE TEAKS TEASK TEKAS TEKSA TESAK TESKA TKAES TKASE TKEAS TKESA TKSAE TKSEA TSAEK TSAKE TSEAK TSEKA TSKAE TSKEA");
            Assert.AreEqual(edabitChallenges.Permutations("RITES"), "EIRST EIRTS EISRT EISTR EITRS EITSR ERIST ERITS ERSIT ERSTI ERTIS ERTSI ESIRT ESITR ESRIT ESRTI ESTIR ESTRI ETIRS ETISR ETRIS ETRSI ETSIR ETSRI IERST IERTS IESRT IESTR IETRS IETSR IREST IRETS IRSET IRSTE IRTES IRTSE ISERT ISETR ISRET ISRTE ISTER ISTRE ITERS ITESR ITRES ITRSE ITSER ITSRE REIST REITS RESIT RESTI RETIS RETSI RIEST RIETS RISET RISTE RITES RITSE RSEIT RSETI RSIET RSITE RSTEI RSTIE RTEIS RTESI RTIES RTISE RTSEI RTSIE SEIRT SEITR SERIT SERTI SETIR SETRI SIERT SIETR SIRET SIRTE SITER SITRE SREIT SRETI SRIET SRITE SRTEI SRTIE STEIR STERI STIER STIRE STREI STRIE TEIRS TEISR TERIS TERSI TESIR TESRI TIERS TIESR TIRES TIRSE TISER TISRE TREIS TRESI TRIES TRISE TRSEI TRSIE TSEIR TSERI TSIER TSIRE TSREI TSRIE");
            Assert.AreEqual(edabitChallenges.Permutations("POOLED"), "DELOOP DELOOP DELOPO DELOPO DELPOO DELPOO DEOLOP DEOLOP DEOLPO DEOLPO DEOOLP DEOOLP DEOOPL DEOOPL DEOPLO DEOPLO DEOPOL DEOPOL DEPLOO DEPLOO DEPOLO DEPOLO DEPOOL DEPOOL DLEOOP DLEOOP DLEOPO DLEOPO DLEPOO DLEPOO DLOEOP DLOEOP DLOEPO DLOEPO DLOOEP DLOOEP DLOOPE DLOOPE DLOPEO DLOPEO DLOPOE DLOPOE DLPEOO DLPEOO DLPOEO DLPOEO DLPOOE DLPOOE DOELOP DOELOP DOELPO DOELPO DOEOLP DOEOLP DOEOPL DOEOPL DOEPLO DOEPLO DOEPOL DOEPOL DOLEOP DOLEOP DOLEPO DOLEPO DOLOEP DOLOEP DOLOPE DOLOPE DOLPEO DOLPEO DOLPOE DOLPOE DOOELP DOOELP DOOEPL DOOEPL DOOLEP DOOLEP DOOLPE DOOLPE DOOPEL DOOPEL DOOPLE DOOPLE DOPELO DOPELO DOPEOL DOPEOL DOPLEO DOPLEO DOPLOE DOPLOE DOPOEL DOPOEL DOPOLE DOPOLE DPELOO DPELOO DPEOLO DPEOLO DPEOOL DPEOOL DPLEOO DPLEOO DPLOEO DPLOEO DPLOOE DPLOOE DPOELO DPOELO DPOEOL DPOEOL DPOLEO DPOLEO DPOLOE DPOLOE DPOOEL DPOOEL DPOOLE DPOOLE EDLOOP EDLOOP EDLOPO EDLOPO EDLPOO EDLPOO EDOLOP EDOLOP EDOLPO EDOLPO EDOOLP EDOOLP EDOOPL EDOOPL EDOPLO EDOPLO EDOPOL EDOPOL EDPLOO EDPLOO EDPOLO EDPOLO EDPOOL EDPOOL ELDOOP ELDOOP ELDOPO ELDOPO ELDPOO ELDPOO ELODOP ELODOP ELODPO ELODPO ELOODP ELOODP ELOOPD ELOOPD ELOPDO ELOPDO ELOPOD ELOPOD ELPDOO ELPDOO ELPODO ELPODO ELPOOD ELPOOD EODLOP EODLOP EODLPO EODLPO EODOLP EODOLP EODOPL EODOPL EODPLO EODPLO EODPOL EODPOL EOLDOP EOLDOP EOLDPO EOLDPO EOLODP EOLODP EOLOPD EOLOPD EOLPDO EOLPDO EOLPOD EOLPOD EOODLP EOODLP EOODPL EOODPL EOOLDP EOOLDP EOOLPD EOOLPD EOOPDL EOOPDL EOOPLD EOOPLD EOPDLO EOPDLO EOPDOL EOPDOL EOPLDO EOPLDO EOPLOD EOPLOD EOPODL EOPODL EOPOLD EOPOLD EPDLOO EPDLOO EPDOLO EPDOLO EPDOOL EPDOOL EPLDOO EPLDOO EPLODO EPLODO EPLOOD EPLOOD EPODLO EPODLO EPODOL EPODOL EPOLDO EPOLDO EPOLOD EPOLOD EPOODL EPOODL EPOOLD EPOOLD LDEOOP LDEOOP LDEOPO LDEOPO LDEPOO LDEPOO LDOEOP LDOEOP LDOEPO LDOEPO LDOOEP LDOOEP LDOOPE LDOOPE LDOPEO LDOPEO LDOPOE LDOPOE LDPEOO LDPEOO LDPOEO LDPOEO LDPOOE LDPOOE LEDOOP LEDOOP LEDOPO LEDOPO LEDPOO LEDPOO LEODOP LEODOP LEODPO LEODPO LEOODP LEOODP LEOOPD LEOOPD LEOPDO LEOPDO LEOPOD LEOPOD LEPDOO LEPDOO LEPODO LEPODO LEPOOD LEPOOD LODEOP LODEOP LODEPO LODEPO LODOEP LODOEP LODOPE LODOPE LODPEO LODPEO LODPOE LODPOE LOEDOP LOEDOP LOEDPO LOEDPO LOEODP LOEODP LOEOPD LOEOPD LOEPDO LOEPDO LOEPOD LOEPOD LOODEP LOODEP LOODPE LOODPE LOOEDP LOOEDP LOOEPD LOOEPD LOOPDE LOOPDE LOOPED LOOPED LOPDEO LOPDEO LOPDOE LOPDOE LOPEDO LOPEDO LOPEOD LOPEOD LOPODE LOPODE LOPOED LOPOED LPDEOO LPDEOO LPDOEO LPDOEO LPDOOE LPDOOE LPEDOO LPEDOO LPEODO LPEODO LPEOOD LPEOOD LPODEO LPODEO LPODOE LPODOE LPOEDO LPOEDO LPOEOD LPOEOD LPOODE LPOODE LPOOED LPOOED ODELOP ODELOP ODELPO ODELPO ODEOLP ODEOLP ODEOPL ODEOPL ODEPLO ODEPLO ODEPOL ODEPOL ODLEOP ODLEOP ODLEPO ODLEPO ODLOEP ODLOEP ODLOPE ODLOPE ODLPEO ODLPEO ODLPOE ODLPOE ODOELP ODOELP ODOEPL ODOEPL ODOLEP ODOLEP ODOLPE ODOLPE ODOPEL ODOPEL ODOPLE ODOPLE ODPELO ODPELO ODPEOL ODPEOL ODPLEO ODPLEO ODPLOE ODPLOE ODPOEL ODPOEL ODPOLE ODPOLE OEDLOP OEDLOP OEDLPO OEDLPO OEDOLP OEDOLP OEDOPL OEDOPL OEDPLO OEDPLO OEDPOL OEDPOL OELDOP OELDOP OELDPO OELDPO OELODP OELODP OELOPD OELOPD OELPDO OELPDO OELPOD OELPOD OEODLP OEODLP OEODPL OEODPL OEOLDP OEOLDP OEOLPD OEOLPD OEOPDL OEOPDL OEOPLD OEOPLD OEPDLO OEPDLO OEPDOL OEPDOL OEPLDO OEPLDO OEPLOD OEPLOD OEPODL OEPODL OEPOLD OEPOLD OLDEOP OLDEOP OLDEPO OLDEPO OLDOEP OLDOEP OLDOPE OLDOPE OLDPEO OLDPEO OLDPOE OLDPOE OLEDOP OLEDOP OLEDPO OLEDPO OLEODP OLEODP OLEOPD OLEOPD OLEPDO OLEPDO OLEPOD OLEPOD OLODEP OLODEP OLODPE OLODPE OLOEDP OLOEDP OLOEPD OLOEPD OLOPDE OLOPDE OLOPED OLOPED OLPDEO OLPDEO OLPDOE OLPDOE OLPEDO OLPEDO OLPEOD OLPEOD OLPODE OLPODE OLPOED OLPOED OODELP OODELP OODEPL OODEPL OODLEP OODLEP OODLPE OODLPE OODPEL OODPEL OODPLE OODPLE OOEDLP OOEDLP OOEDPL OOEDPL OOELDP OOELDP OOELPD OOELPD OOEPDL OOEPDL OOEPLD OOEPLD OOLDEP OOLDEP OOLDPE OOLDPE OOLEDP OOLEDP OOLEPD OOLEPD OOLPDE OOLPDE OOLPED OOLPED OOPDEL OOPDEL OOPDLE OOPDLE OOPEDL OOPEDL OOPELD OOPELD OOPLDE OOPLDE OOPLED OOPLED OPDELO OPDELO OPDEOL OPDEOL OPDLEO OPDLEO OPDLOE OPDLOE OPDOEL OPDOEL OPDOLE OPDOLE OPEDLO OPEDLO OPEDOL OPEDOL OPELDO OPELDO OPELOD OPELOD OPEODL OPEODL OPEOLD OPEOLD OPLDEO OPLDEO OPLDOE OPLDOE OPLEDO OPLEDO OPLEOD OPLEOD OPLODE OPLODE OPLOED OPLOED OPODEL OPODEL OPODLE OPODLE OPOEDL OPOEDL OPOELD OPOELD OPOLDE OPOLDE OPOLED OPOLED PDELOO PDELOO PDEOLO PDEOLO PDEOOL PDEOOL PDLEOO PDLEOO PDLOEO PDLOEO PDLOOE PDLOOE PDOELO PDOELO PDOEOL PDOEOL PDOLEO PDOLEO PDOLOE PDOLOE PDOOEL PDOOEL PDOOLE PDOOLE PEDLOO PEDLOO PEDOLO PEDOLO PEDOOL PEDOOL PELDOO PELDOO PELODO PELODO PELOOD PELOOD PEODLO PEODLO PEODOL PEODOL PEOLDO PEOLDO PEOLOD PEOLOD PEOODL PEOODL PEOOLD PEOOLD PLDEOO PLDEOO PLDOEO PLDOEO PLDOOE PLDOOE PLEDOO PLEDOO PLEODO PLEODO PLEOOD PLEOOD PLODEO PLODEO PLODOE PLODOE PLOEDO PLOEDO PLOEOD PLOEOD PLOODE PLOODE PLOOED PLOOED PODELO PODELO PODEOL PODEOL PODLEO PODLEO PODLOE PODLOE PODOEL PODOEL PODOLE PODOLE POEDLO POEDLO POEDOL POEDOL POELDO POELDO POELOD POELOD POEODL POEODL POEOLD POEOLD POLDEO POLDEO POLDOE POLDOE POLEDO POLEDO POLEOD POLEOD POLODE POLODE POLOED POLOED POODEL POODEL POODLE POODLE POOEDL POOEDL POOELD POOELD POOLDE POOLDE POOLED POOLED");
            Assert.AreEqual(edabitChallenges.Permutations("TRANCE"), "ACENRT ACENTR ACERNT ACERTN ACETNR ACETRN ACNERT ACNETR ACNRET ACNRTE ACNTER ACNTRE ACRENT ACRETN ACRNET ACRNTE ACRTEN ACRTNE ACTENR ACTERN ACTNER ACTNRE ACTREN ACTRNE AECNRT AECNTR AECRNT AECRTN AECTNR AECTRN AENCRT AENCTR AENRCT AENRTC AENTCR AENTRC AERCNT AERCTN AERNCT AERNTC AERTCN AERTNC AETCNR AETCRN AETNCR AETNRC AETRCN AETRNC ANCERT ANCETR ANCRET ANCRTE ANCTER ANCTRE ANECRT ANECTR ANERCT ANERTC ANETCR ANETRC ANRCET ANRCTE ANRECT ANRETC ANRTCE ANRTEC ANTCER ANTCRE ANTECR ANTERC ANTRCE ANTREC ARCENT ARCETN ARCNET ARCNTE ARCTEN ARCTNE ARECNT ARECTN ARENCT ARENTC ARETCN ARETNC ARNCET ARNCTE ARNECT ARNETC ARNTCE ARNTEC ARTCEN ARTCNE ARTECN ARTENC ARTNCE ARTNEC ATCENR ATCERN ATCNER ATCNRE ATCREN ATCRNE ATECNR ATECRN ATENCR ATENRC ATERCN ATERNC ATNCER ATNCRE ATNECR ATNERC ATNRCE ATNREC ATRCEN ATRCNE ATRECN ATRENC ATRNCE ATRNEC CAENRT CAENTR CAERNT CAERTN CAETNR CAETRN CANERT CANETR CANRET CANRTE CANTER CANTRE CARENT CARETN CARNET CARNTE CARTEN CARTNE CATENR CATERN CATNER CATNRE CATREN CATRNE CEANRT CEANTR CEARNT CEARTN CEATNR CEATRN CENART CENATR CENRAT CENRTA CENTAR CENTRA CERANT CERATN CERNAT CERNTA CERTAN CERTNA CETANR CETARN CETNAR CETNRA CETRAN CETRNA CNAERT CNAETR CNARET CNARTE CNATER CNATRE CNEART CNEATR CNERAT CNERTA CNETAR CNETRA CNRAET CNRATE CNREAT CNRETA CNRTAE CNRTEA CNTAER CNTARE CNTEAR CNTERA CNTRAE CNTREA CRAENT CRAETN CRANET CRANTE CRATEN CRATNE CREANT CREATN CRENAT CRENTA CRETAN CRETNA CRNAET CRNATE CRNEAT CRNETA CRNTAE CRNTEA CRTAEN CRTANE CRTEAN CRTENA CRTNAE CRTNEA CTAENR CTAERN CTANER CTANRE CTAREN CTARNE CTEANR CTEARN CTENAR CTENRA CTERAN CTERNA CTNAER CTNARE CTNEAR CTNERA CTNRAE CTNREA CTRAEN CTRANE CTREAN CTRENA CTRNAE CTRNEA EACNRT EACNTR EACRNT EACRTN EACTNR EACTRN EANCRT EANCTR EANRCT EANRTC EANTCR EANTRC EARCNT EARCTN EARNCT EARNTC EARTCN EARTNC EATCNR EATCRN EATNCR EATNRC EATRCN EATRNC ECANRT ECANTR ECARNT ECARTN ECATNR ECATRN ECNART ECNATR ECNRAT ECNRTA ECNTAR ECNTRA ECRANT ECRATN ECRNAT ECRNTA ECRTAN ECRTNA ECTANR ECTARN ECTNAR ECTNRA ECTRAN ECTRNA ENACRT ENACTR ENARCT ENARTC ENATCR ENATRC ENCART ENCATR ENCRAT ENCRTA ENCTAR ENCTRA ENRACT ENRATC ENRCAT ENRCTA ENRTAC ENRTCA ENTACR ENTARC ENTCAR ENTCRA ENTRAC ENTRCA ERACNT ERACTN ERANCT ERANTC ERATCN ERATNC ERCANT ERCATN ERCNAT ERCNTA ERCTAN ERCTNA ERNACT ERNATC ERNCAT ERNCTA ERNTAC ERNTCA ERTACN ERTANC ERTCAN ERTCNA ERTNAC ERTNCA ETACNR ETACRN ETANCR ETANRC ETARCN ETARNC ETCANR ETCARN ETCNAR ETCNRA ETCRAN ETCRNA ETNACR ETNARC ETNCAR ETNCRA ETNRAC ETNRCA ETRACN ETRANC ETRCAN ETRCNA ETRNAC ETRNCA NACERT NACETR NACRET NACRTE NACTER NACTRE NAECRT NAECTR NAERCT NAERTC NAETCR NAETRC NARCET NARCTE NARECT NARETC NARTCE NARTEC NATCER NATCRE NATECR NATERC NATRCE NATREC NCAERT NCAETR NCARET NCARTE NCATER NCATRE NCEART NCEATR NCERAT NCERTA NCETAR NCETRA NCRAET NCRATE NCREAT NCRETA NCRTAE NCRTEA NCTAER NCTARE NCTEAR NCTERA NCTRAE NCTREA NEACRT NEACTR NEARCT NEARTC NEATCR NEATRC NECART NECATR NECRAT NECRTA NECTAR NECTRA NERACT NERATC NERCAT NERCTA NERTAC NERTCA NETACR NETARC NETCAR NETCRA NETRAC NETRCA NRACET NRACTE NRAECT NRAETC NRATCE NRATEC NRCAET NRCATE NRCEAT NRCETA NRCTAE NRCTEA NREACT NREATC NRECAT NRECTA NRETAC NRETCA NRTACE NRTAEC NRTCAE NRTCEA NRTEAC NRTECA NTACER NTACRE NTAECR NTAERC NTARCE NTAREC NTCAER NTCARE NTCEAR NTCERA NTCRAE NTCREA NTEACR NTEARC NTECAR NTECRA NTERAC NTERCA NTRACE NTRAEC NTRCAE NTRCEA NTREAC NTRECA RACENT RACETN RACNET RACNTE RACTEN RACTNE RAECNT RAECTN RAENCT RAENTC RAETCN RAETNC RANCET RANCTE RANECT RANETC RANTCE RANTEC RATCEN RATCNE RATECN RATENC RATNCE RATNEC RCAENT RCAETN RCANET RCANTE RCATEN RCATNE RCEANT RCEATN RCENAT RCENTA RCETAN RCETNA RCNAET RCNATE RCNEAT RCNETA RCNTAE RCNTEA RCTAEN RCTANE RCTEAN RCTENA RCTNAE RCTNEA REACNT REACTN REANCT REANTC REATCN REATNC RECANT RECATN RECNAT RECNTA RECTAN RECTNA RENACT RENATC RENCAT RENCTA RENTAC RENTCA RETACN RETANC RETCAN RETCNA RETNAC RETNCA RNACET RNACTE RNAECT RNAETC RNATCE RNATEC RNCAET RNCATE RNCEAT RNCETA RNCTAE RNCTEA RNEACT RNEATC RNECAT RNECTA RNETAC RNETCA RNTACE RNTAEC RNTCAE RNTCEA RNTEAC RNTECA RTACEN RTACNE RTAECN RTAENC RTANCE RTANEC RTCAEN RTCANE RTCEAN RTCENA RTCNAE RTCNEA RTEACN RTEANC RTECAN RTECNA RTENAC RTENCA RTNACE RTNAEC RTNCAE RTNCEA RTNEAC RTNECA TACENR TACERN TACNER TACNRE TACREN TACRNE TAECNR TAECRN TAENCR TAENRC TAERCN TAERNC TANCER TANCRE TANECR TANERC TANRCE TANREC TARCEN TARCNE TARECN TARENC TARNCE TARNEC TCAENR TCAERN TCANER TCANRE TCAREN TCARNE TCEANR TCEARN TCENAR TCENRA TCERAN TCERNA TCNAER TCNARE TCNEAR TCNERA TCNRAE TCNREA TCRAEN TCRANE TCREAN TCRENA TCRNAE TCRNEA TEACNR TEACRN TEANCR TEANRC TEARCN TEARNC TECANR TECARN TECNAR TECNRA TECRAN TECRNA TENACR TENARC TENCAR TENCRA TENRAC TENRCA TERACN TERANC TERCAN TERCNA TERNAC TERNCA TNACER TNACRE TNAECR TNAERC TNARCE TNAREC TNCAER TNCARE TNCEAR TNCERA TNCRAE TNCREA TNEACR TNEARC TNECAR TNECRA TNERAC TNERCA TNRACE TNRAEC TNRCAE TNRCEA TNREAC TNRECA TRACEN TRACNE TRAECN TRAENC TRANCE TRANEC TRCAEN TRCANE TRCEAN TRCENA TRCNAE TRCNEA TREACN TREANC TRECAN TRECNA TRENAC TRENCA TRNACE TRNAEC TRNCAE TRNCEA TRNEAC TRNECA");
            Assert.AreEqual(edabitChallenges.Permutations("ASCENT"), "ACENST ACENTS ACESNT ACESTN ACETNS ACETSN ACNEST ACNETS ACNSET ACNSTE ACNTES ACNTSE ACSENT ACSETN ACSNET ACSNTE ACSTEN ACSTNE ACTENS ACTESN ACTNES ACTNSE ACTSEN ACTSNE AECNST AECNTS AECSNT AECSTN AECTNS AECTSN AENCST AENCTS AENSCT AENSTC AENTCS AENTSC AESCNT AESCTN AESNCT AESNTC AESTCN AESTNC AETCNS AETCSN AETNCS AETNSC AETSCN AETSNC ANCEST ANCETS ANCSET ANCSTE ANCTES ANCTSE ANECST ANECTS ANESCT ANESTC ANETCS ANETSC ANSCET ANSCTE ANSECT ANSETC ANSTCE ANSTEC ANTCES ANTCSE ANTECS ANTESC ANTSCE ANTSEC ASCENT ASCETN ASCNET ASCNTE ASCTEN ASCTNE ASECNT ASECTN ASENCT ASENTC ASETCN ASETNC ASNCET ASNCTE ASNECT ASNETC ASNTCE ASNTEC ASTCEN ASTCNE ASTECN ASTENC ASTNCE ASTNEC ATCENS ATCESN ATCNES ATCNSE ATCSEN ATCSNE ATECNS ATECSN ATENCS ATENSC ATESCN ATESNC ATNCES ATNCSE ATNECS ATNESC ATNSCE ATNSEC ATSCEN ATSCNE ATSECN ATSENC ATSNCE ATSNEC CAENST CAENTS CAESNT CAESTN CAETNS CAETSN CANEST CANETS CANSET CANSTE CANTES CANTSE CASENT CASETN CASNET CASNTE CASTEN CASTNE CATENS CATESN CATNES CATNSE CATSEN CATSNE CEANST CEANTS CEASNT CEASTN CEATNS CEATSN CENAST CENATS CENSAT CENSTA CENTAS CENTSA CESANT CESATN CESNAT CESNTA CESTAN CESTNA CETANS CETASN CETNAS CETNSA CETSAN CETSNA CNAEST CNAETS CNASET CNASTE CNATES CNATSE CNEAST CNEATS CNESAT CNESTA CNETAS CNETSA CNSAET CNSATE CNSEAT CNSETA CNSTAE CNSTEA CNTAES CNTASE CNTEAS CNTESA CNTSAE CNTSEA CSAENT CSAETN CSANET CSANTE CSATEN CSATNE CSEANT CSEATN CSENAT CSENTA CSETAN CSETNA CSNAET CSNATE CSNEAT CSNETA CSNTAE CSNTEA CSTAEN CSTANE CSTEAN CSTENA CSTNAE CSTNEA CTAENS CTAESN CTANES CTANSE CTASEN CTASNE CTEANS CTEASN CTENAS CTENSA CTESAN CTESNA CTNAES CTNASE CTNEAS CTNESA CTNSAE CTNSEA CTSAEN CTSANE CTSEAN CTSENA CTSNAE CTSNEA EACNST EACNTS EACSNT EACSTN EACTNS EACTSN EANCST EANCTS EANSCT EANSTC EANTCS EANTSC EASCNT EASCTN EASNCT EASNTC EASTCN EASTNC EATCNS EATCSN EATNCS EATNSC EATSCN EATSNC ECANST ECANTS ECASNT ECASTN ECATNS ECATSN ECNAST ECNATS ECNSAT ECNSTA ECNTAS ECNTSA ECSANT ECSATN ECSNAT ECSNTA ECSTAN ECSTNA ECTANS ECTASN ECTNAS ECTNSA ECTSAN ECTSNA ENACST ENACTS ENASCT ENASTC ENATCS ENATSC ENCAST ENCATS ENCSAT ENCSTA ENCTAS ENCTSA ENSACT ENSATC ENSCAT ENSCTA ENSTAC ENSTCA ENTACS ENTASC ENTCAS ENTCSA ENTSAC ENTSCA ESACNT ESACTN ESANCT ESANTC ESATCN ESATNC ESCANT ESCATN ESCNAT ESCNTA ESCTAN ESCTNA ESNACT ESNATC ESNCAT ESNCTA ESNTAC ESNTCA ESTACN ESTANC ESTCAN ESTCNA ESTNAC ESTNCA ETACNS ETACSN ETANCS ETANSC ETASCN ETASNC ETCANS ETCASN ETCNAS ETCNSA ETCSAN ETCSNA ETNACS ETNASC ETNCAS ETNCSA ETNSAC ETNSCA ETSACN ETSANC ETSCAN ETSCNA ETSNAC ETSNCA NACEST NACETS NACSET NACSTE NACTES NACTSE NAECST NAECTS NAESCT NAESTC NAETCS NAETSC NASCET NASCTE NASECT NASETC NASTCE NASTEC NATCES NATCSE NATECS NATESC NATSCE NATSEC NCAEST NCAETS NCASET NCASTE NCATES NCATSE NCEAST NCEATS NCESAT NCESTA NCETAS NCETSA NCSAET NCSATE NCSEAT NCSETA NCSTAE NCSTEA NCTAES NCTASE NCTEAS NCTESA NCTSAE NCTSEA NEACST NEACTS NEASCT NEASTC NEATCS NEATSC NECAST NECATS NECSAT NECSTA NECTAS NECTSA NESACT NESATC NESCAT NESCTA NESTAC NESTCA NETACS NETASC NETCAS NETCSA NETSAC NETSCA NSACET NSACTE NSAECT NSAETC NSATCE NSATEC NSCAET NSCATE NSCEAT NSCETA NSCTAE NSCTEA NSEACT NSEATC NSECAT NSECTA NSETAC NSETCA NSTACE NSTAEC NSTCAE NSTCEA NSTEAC NSTECA NTACES NTACSE NTAECS NTAESC NTASCE NTASEC NTCAES NTCASE NTCEAS NTCESA NTCSAE NTCSEA NTEACS NTEASC NTECAS NTECSA NTESAC NTESCA NTSACE NTSAEC NTSCAE NTSCEA NTSEAC NTSECA SACENT SACETN SACNET SACNTE SACTEN SACTNE SAECNT SAECTN SAENCT SAENTC SAETCN SAETNC SANCET SANCTE SANECT SANETC SANTCE SANTEC SATCEN SATCNE SATECN SATENC SATNCE SATNEC SCAENT SCAETN SCANET SCANTE SCATEN SCATNE SCEANT SCEATN SCENAT SCENTA SCETAN SCETNA SCNAET SCNATE SCNEAT SCNETA SCNTAE SCNTEA SCTAEN SCTANE SCTEAN SCTENA SCTNAE SCTNEA SEACNT SEACTN SEANCT SEANTC SEATCN SEATNC SECANT SECATN SECNAT SECNTA SECTAN SECTNA SENACT SENATC SENCAT SENCTA SENTAC SENTCA SETACN SETANC SETCAN SETCNA SETNAC SETNCA SNACET SNACTE SNAECT SNAETC SNATCE SNATEC SNCAET SNCATE SNCEAT SNCETA SNCTAE SNCTEA SNEACT SNEATC SNECAT SNECTA SNETAC SNETCA SNTACE SNTAEC SNTCAE SNTCEA SNTEAC SNTECA STACEN STACNE STAECN STAENC STANCE STANEC STCAEN STCANE STCEAN STCENA STCNAE STCNEA STEACN STEANC STECAN STECNA STENAC STENCA STNACE STNAEC STNCAE STNCEA STNEAC STNECA TACENS TACESN TACNES TACNSE TACSEN TACSNE TAECNS TAECSN TAENCS TAENSC TAESCN TAESNC TANCES TANCSE TANECS TANESC TANSCE TANSEC TASCEN TASCNE TASECN TASENC TASNCE TASNEC TCAENS TCAESN TCANES TCANSE TCASEN TCASNE TCEANS TCEASN TCENAS TCENSA TCESAN TCESNA TCNAES TCNASE TCNEAS TCNESA TCNSAE TCNSEA TCSAEN TCSANE TCSEAN TCSENA TCSNAE TCSNEA TEACNS TEACSN TEANCS TEANSC TEASCN TEASNC TECANS TECASN TECNAS TECNSA TECSAN TECSNA TENACS TENASC TENCAS TENCSA TENSAC TENSCA TESACN TESANC TESCAN TESCNA TESNAC TESNCA TNACES TNACSE TNAECS TNAESC TNASCE TNASEC TNCAES TNCASE TNCEAS TNCESA TNCSAE TNCSEA TNEACS TNEASC TNECAS TNECSA TNESAC TNESCA TNSACE TNSAEC TNSCAE TNSCEA TNSEAC TNSECA TSACEN TSACNE TSAECN TSAENC TSANCE TSANEC TSCAEN TSCANE TSCEAN TSCENA TSCNAE TSCNEA TSEACN TSEANC TSECAN TSECNA TSENAC TSENCA TSNACE TSNAEC TSNCAE TSNCEA TSNEAC TSNECA");
        }

        #endregion VeryHard

        #region Expert

        [TestCase(1, ExpectedResult = "1")]
        [TestCase(3, ExpectedResult = "6")]
        [TestCase(6, ExpectedResult = "60")]
        [TestCase(5, ExpectedResult = "60")]
        [TestCase(10, ExpectedResult = "2520")]
        [TestCase(20, ExpectedResult = "232792560")]
        public string GivenAPosInt_ReturnSmallestNumberDivisibleByIntThrough1(int n)
        {
            return edabitChallenges.Smallest(n);
        }
        
        [TestCase(11211230, ExpectedResult = false)]
        [TestCase(13001120, ExpectedResult = true)]
        [TestCase(23336014, ExpectedResult = true)]
        [TestCase(11, ExpectedResult = true)]
        [TestCase(1122, ExpectedResult = false)]
        [TestCase(332233, ExpectedResult = true)]
        [TestCase(10210112, ExpectedResult = true)]
        [TestCase(9735, ExpectedResult = false)]
        [TestCase(97358817, ExpectedResult = false)]
        public bool PalindromeDescendant(int num)
        {
            return edabitChallenges.PalindromeDescendant(num);
        }


        #endregion Expert
    }
}